/********************************** (C) COPYRIGHT *******************************
 * File Name          : main.c
 * Author             : WCH
 * Version            : V1.1
 * Date               : 2020/08/06
 * Description        : ӻӦϵͳʼ
 *********************************************************************************
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * Attention: This software (modified or not) and binary are used for
 * microcontroller manufactured by Nanjing Qinheng Microelectronics.
 *******************************************************************************/

/******************************************************************************/
/* ͷļ */
#include "CONFIG.h"
#include "HAL.h"
#include "gattprofile.h"
#include "peripheral.h"

#include "bsp_adc.h"

#include "bsp_key.h"

#include "bsp_beep_led_emv.h"

/*********************************************************************
 * GLOBAL TYPEDEFS
 */
__attribute__((aligned(4))) uint32_t MEM_BUF[BLE_MEMHEAP_SIZE / 4];

#if (defined(BLE_MAC)) && (BLE_MAC == TRUE)
const uint8_t MacAddr[6] = {0x84, 0xC2, 0xE4, 0x03, 0x02, 0x02};
#endif

/*********************************************************************
 * @fn      Main_Circulation
 *
 * @brief   ѭ
 *
 * @return  none
 */
__HIGH_CODE
__attribute__((noinline)) void Main_Circulation()
{
    while (1)
    {
        TMOS_SystemProcess();
        if (GPIOB_ReadPortPin(GPIO_Pin_15) == 0)
        {
            // 12V_EN
            BOOST_EN;
            PRINT("BOOST_EN\n");

            // LED_R
            LED_R_ON;
            DelayMs(1000);
            PRINT("LED_R_ON\n");

            LED_ALL_OFF_DEINIT;
            DelayMs(1000);
            PRINT("LED_ALL_OFF_DEINIT\n");

            // BEEP
            BEEP_ON;
            DelayMs(1000);
            PRINT("BEEP_ON\n");
            BEEP_OFF_DEINIT;
            DelayMs(1000);
            PRINT("BEEP_OFF_DEINIT\n");

            // LED_G
            LED_G_ON;
            DelayMs(1000);
            PRINT("LED_G_ON\n");

            LED_ALL_OFF_DEINIT;
            DelayMs(1000);
            PRINT("LED_ALL_OFF_DEINIT\n");

            // LED_Y
            LED_Y_ON;
            DelayMs(1000);
            PRINT("LED_Y_ON\n");

            LED_ALL_OFF_DEINIT;
            DelayMs(1000);
            PRINT("LED_ALL_OFF_DEINIT\n");


            PRINT("Delay 6s\n");

            // EMV_CHARGE
            EMV_CHARGE_EN;
            PRINT("EMV_CHARGE_EN\n");

            DelayMs(1000);

            EMV_CHARGE_OFF_DEINIT;
            PRINT("EMV_CHARGE_OFF_DEINIT 500 ms\n");

            // EMV_CTRL
            EMV_ON;
            PRINT("EMV_ON\n");
            DelayMs(100);

            BOOST_OFF_DEINIT;
            BEEP_OFF_DEINIT;
            LED_ALL_OFF_DEINIT;
            EMV_CHARGE_OFF_DEINIT;
            EMV_OFF_DEINIT;
        }
    }
}

/*********************************************************************
 * @fn      main
 *
 * @brief   
 *
 * @return  none
 */
int main(void)
{
#if (defined(DCDC_ENABLE)) && (DCDC_ENABLE == TRUE)
    PWR_DCDCCfg(ENABLE);
#endif
    SetSysClock(CLK_SOURCE_PLL_60MHz);

#if (defined(HAL_SLEEP)) && (HAL_SLEEP == TRUE)
    GPIOA_ModeCfg(GPIO_Pin_All, GPIO_ModeIN_PD);
    GPIOB_ModeCfg(GPIO_Pin_All, GPIO_ModeIN_PD);
#endif
#ifdef DEBUG
    GPIOA_SetBits(bTXD1);
    GPIOA_ModeCfg(bTXD1, GPIO_ModeOut_PP_5mA);
    UART1_DefInit();
    PRINT("Start @ChipID=%02X\n", R8_CHIP_ID);
#endif

    DelayMs(1000 * 3);

    BOOST_OFF_DEINIT;
    BEEP_OFF_DEINIT;
    LED_ALL_OFF_DEINIT;
    EMV_CHARGE_OFF_DEINIT;
    EMV_OFF_DEINIT;

    BSP_KEY_Init();

    BSP_ADC_Init();

    PRINT("%s\n", VER_LIB);
    // while (1)
    // {
    //     DelayMs(1000);
    // }

    CH59x_BLEInit();
    HAL_Init();
    GAPRole_PeripheralInit();
    Peripheral_Init();
    Main_Circulation();
}

/******************************** endfile @ main ******************************/
